*
* $Id: gpgeo.F,v 3.3 2005/06/21 02:41:47 cafagna Exp $
*
* $Log: gpgeo.F,v $
* Revision 3.3  2005/06/21 02:41:47  cafagna
* Major modification to the geometry and to the random number chain
*
* Revision 3.2  2002/12/04 15:12:54  pamela
* CAS and CALO geometry modified
*
* Revision 3.1.1.1  2002/07/11 16:02:00  cafagna
* First GPAMELA release on CVS
*
*
*               16/07/2004  16.44.06  by  Alexey Bakaldin
*               15/10/2002  15.29.36  by  Jens Lund
*CMZ :  3.00/00 13/11/2000  09.03.11  by  Emiliano Mocchiutti
*CMZ :  2.01/00 05/04/2000  14.35.17  by  Marialuigia Ambriola
*CMZ :  2.00/00 03/03/2000  15.39.05  by  Francesco Cafagna
*CMZ :  1.02/00 08/11/99  18.44.50  by  Francesco Cafagna
*CMZ :  1.01/00 13/05/96  09.16.26  by  Francesco Cafagna
*CMZ :  1.00/02 04/04/96  12.00.53  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   05/12/95
      SUBROUTINE GPGEO
************************************************************************
*                                                                      *
* Volumes definition for PAMELA                                        *
*                                                                      *
* Called by: UGINIT                                                    *
* Author: Francesco Cafagna, 05/12/95 13.21.27                         *
*                                                                      *
************************************************************************
#include "gpgeo.inc"
#include "gpmed.inc"
#include "gpkey.inc"
*
      INTEGER IROT,IVOLU,N,NMED,NUM
      REAL X,Y,Z
*
*  Define 90 degree rotation around Z axis
*
      IROT=1
      CALL GSROTM(IROT,90.,90.,90.,180.,0.,0.)
*
*  Define 90 degree rotation around X axis
*
      IROT=2
      CALL GSROTM(IROT,90.,0.,180.,90.,90.,90.)
*
*  Define 90 degree rotation around Z axis and 180 along X
*
      IROT=3
      CALL GSROTM(IROT,90.,90.,90.,360.,180.,0.)
*
*  Define 180 degree rotation around Z axis
*
      IROT=4
      CALL GSROTM(IROT,90.,180.,90.,270.,0.,0.)
*JeL:
*
*  Define 180 degree rotation aroun Z axis and 180 along X
*
      IROT=5
      CALL GSROTM(IROT,90.,180.,90.,90.,180.,0.)
*
*  Define 270 degree rotation around Z axis
*
      IROT=6
      CALL GSROTM(IROT,90.,270.,90.,360.,0.,0.)
*
*  Define 90 degree rotation around Y axis
*
      IROT = 7
      CALL GSROTM(IROT,0.,0.,90.,90.,90.,180.)
*
*  Define 270 degree rotation around Y axis
*
      IROT = 8
      CALL GSROTM(IROT,180.,0.,90.,90.,90.,0.)
*
*  Define 180 degree rotation around Y axis
*
      IROT=9
      CALL GSROTM(IROT,90.,180.,90.,90.,180.,0.)
*
*  Define 180 degree rotation around X axis
*
      IROT=10
      CALL GSROTM(IROT,90.,0.,90.,270.,180.,0.)

*END: JeL.
*
*  Define the PAMELA   volume
*
      NMED=MN2
      CALL GSVOLU('PAME','TUBE',NMED,PAME, 3,IVOLU)
*AB:
*
*  Define the Aluminium shell volumes
*
      NMED=MAL
C      CALL GSVOLU('SHEL','TUBE',NMED,SHEL, 3,IVOLU)
      CALL GSVOLU('SHEL','CONE',NMED,SHEL, 5,IVOLU)
*
*  Define the Aluminium inner shell volumes
*
      IF(SPH) THEN
         NMED=MAL
         CALL GSVOLU('TSPH','SPHE',NMED,TSPH, 6,IVOLU)
      ELSE
         NMED=MAL
         CALL GSVOLU('TFLA','TUBE',NMED,TFLA, 3,IVOLU)
      ENDIF
*
*  Define the Aluminium shell volumes
*
      NMED=MAL
      CALL GSVOLU('MSHE','TUBE',NMED,MSHE, 3,IVOLU)
*
*  Define the Aluminium shell volumes
*
      NMED=MAL
      CALL GSVOLU('BSPH','SPHE',NMED,BSPH, 6,IVOLU)
*END: AB.
c ml: 28/10/04 
*
*  Define the top plate (to be completed) 
*
      NMED=MN2
cfc      CALL GSVOLU('TPLA','BOX ',NMED,TPLA, 3,IVOLU)
c end ml.
*
* Volume definition for scintillators, TOF and anticoincidence counter
*
      IF(TOF) CALL GPTOFV
      IF(CAT) CALL GPCATV
      IF(CAS) CALL GPCASV
*
* Volume definition for TRD
*
      IF(TRD) CALL GPTRDV
*
* Volume definition for Spectrometer
*
      IF(SPE) CALL GPSPEV
*
* Volume definition for Calorimeter
*
      IF(CAL) CALL GPCALV

*
*  Volume positioning starting from the TOP
*
      X= 0.
      Y= 0.
*
* Positioning volume SHEL     into the mother PAME
*
      N= 1
      Z= ZSHEL
      CALL GSPOS('SHEL',N,'PAME',X,Y,Z,0,'ONLY')
*
* Positioning volume SHEI     into the mother PAME
*
C         N= 1
C         Z= ZSHEI
c         CALL GSPOS('SHEI',N,'PAME',X,Y,Z,0,'ONLY')
      IF(SPH) THEN
*
* Positioning volume TSPH     into the mother PAME
*
         N= 1
         Z= ZTSPH
         CALL GSPOS('TSPH',N,'PAME',X,Y,Z,0,'ONLY')
      ELSE
*
* Positioning volume TFLA     into the mother PAME
*
         N= 1
         Z= ZTFLA
         CALL GSPOS('TFLA',N,'PAME',X,Y,Z,0,'ONLY')
      ENDIF
*AB:
*
* Positioning volume MSHE     into the mother PAME
*
         N= 1
         Z= ZMSHE
         CALL GSPOS('MSHE',N,'PAME',X,Y,Z,0,'ONLY')
*
* Positioning volume BSPH     into the mother PAME
*
         N= 1
         Z= ZBSPH
         CALL GSPOS('BSPH',N,'PAME',X,Y,Z,0,'ONLY')
*END: AB.
*
* Positioning volume S11     into the mother PAME
*
      N= 1
c ml:24/11/04
      Z=ZCAL+CALS(3)+3.7+2*(SPEB(3)+TPLA(3)+S22(3)+S21(3)+CATA(2))+ 
     +     26.4+2*S12(3)+S11(3)
C      Z= ZS11
      IF(TOF) CALL GSPOS('S11 ',N,'PAME',X,Y,Z,0,'ONLY')
c end ml.
*
* Positioning volume S12     into the mother PAME
*
      N= 1
c ml:24/11/04
      Z=ZCAL+CALS(3)+3.7+2*(SPEB(3)+TPLA(3)+S22(3)+S21(3)+CATA(2))+ 
     +     26.4+S12(3)
C      Z= ZS12
      IF(TOF) CALL GSPOS('S12 ',N,'PAME',X,Y,Z,0,'ONLY')
c end ml.
*
* Positioning volume TRDB     into the mother PAME
*
      N= 1
c ml:24/11/04
      Z=ZCAL+CALS(3)+3.7+2*(SPEB(3)+TPLA(3)+S22(3)+S21(3)+CATA(2))+ 
     +     TRDB(3)
c      Z= ZTRD
      IF(TRD) THEN
         CALL GSPOS('TRDB',N,'PAME',X,Y,Z,0,'ONLY')
c end ml.
C FC commented out on 21-10-1999 by caf
c         CALL GSPOS('TRDS',N,'PAME',X,Y,Z,0,'ONLY')
c         Z= ZTRD - TRDS(3) - TRDT(3)
c         CALL GSPOS('TRDT',N,'PAME',X,Y,Z,0,'ONLY')
c         N= 2
c         Z= ZTRD + TRDS(3) + TRDT(3)
c         CALL GSPOS('TRDT',N,'PAME',X,Y,Z,0,'ONLY')
C FC end of comment on 21-10-1999
      ENDIF
*
* Positioning volume S21     into the mother PAME
*
      N= 1
c ml:24/11/04
      Z=ZCAL+CALS(3)+3.7+2*SPEB(3)+2*TPLA(3)+2*S22(3)+S21(3)
c      Z= ZS21
      IF(TOF) CALL GSPOS('S21 ',N,'PAME',X,Y,Z,0,'ONLY')
c  end ml.
*
* Positioning volume S22     into the mother PAME
*
      N= 1
c ml:24/11/04
      Z=ZCAL+CALS(3)+3.7+2*SPEB(3)+2*TPLA(3)+S22(3)
c      Z= ZS22
      IF(TOF) CALL GSPOS('S22 ',N,'PAME',X,Y,Z,0,'ONLY')
c end ml.
c ml: 28/10/04
*
*  Positioning volume TPLA into the mother PAME
*
      N=1
c ml:24/11/04
      Z=ZCAL+CALS(3)+3.7+2*SPEB(3)+TPLA(3)
c      Z=ZTPLA
cfc      CALL GSPOS('TPLA',N,'PAME',X,Y,Z,0,'ONLY')
c end ml.
*JeL:
*
* Positioning volume CATA     into the mother PAME
*
      N= 1
c ml:24/11/04
      Z=ZCAL+CALS(3)+3.7+2*(SPEB(3)+TPLA(3)+S21(3)+S22(3))+CATA(2)
C      Z= ZCAT
C Com. by JeL IF(CAT) CALL GSPOS('CATB',N,'PAME',X,Y,Z,0,'ONLY')
      IF(CAT) CALL GSPOS('CATA',N,'PAME',X,Y,Z,2,'ONLY')
c end ml.
*END: JeL.
*
* Positioning volume CAS      into the mother PAME
*
*EM:
*JeL:
C      Z= ZCAS
       Z= ZSPEC-2.1
*end JeL.
      IF(CAS) THEN
*com by JeL:
CC         X = 0
C         N = 0
C         DO I = 1,2
C            X = ((-1)**(I+1))*CASXD
CC            Y = ((-1)**I)*( CASY(2) + CASX(2) )
C            Y = ((-1)**I)*CASY(2)
Cc fc mod by caf on 21-10-1999
Cc            DO II=1, 5
Cc               Z = ZCAS - 4.*CASX(3) + (II-1) * 2*CASX(3)
Cc               N = N + 1
Cc               CALL GSPOS('CASX',N,'PAME',X,Y,Z,0,'ONLY')
Cc            ENDDO
Cc fc end mod
C            Z = ZCAS
C            N = N + 1
C*
C            CALL GSPOS('CSSX',N,'PAME',X,Y,Z,0,'ONLY')
C         ENDDO
C*
CC         Y = 0
C         N = 0
C         DO I = 1,2
C            X = ((-1)**I)*(CASX(1)+0.1)
CC            X = ((-1)**I)*(CASX(1)+CASY(1))
C            Y = ((-1)**I)*CASYD
Cc fc mod by caf on 21-10-1999
Cc            DO II=1, 5
Cc               Z = ZCAS - 4.*CASY(3) + (II-1) * 2*CASY(3)
Cc               N = N + 1
Cc               CALL GSPOS('CASY',N,'PAME',X,Y,Z,0,'ONLY')
Cc            ENDDO
Cc fc end mod
C            Z = ZCAS
C            N = N + 1
C            CALL GSPOS('CSSY',N,'PAME',X,Y,Z,0,'ONLY')
C         ENDDO
*end com by JeL.
*JeL:
         N = 1
*ML:
C         X = 10.75
         X = 8.872
C         Y = -14.1
         Y = -17.215
*END ML.
         CALL GSPOS('CASA',N,'PAME',X,Y,Z,0,'ONLY')
         N = 2
*ML:
C         X = 14.1
         X = 17.9285
C         Y = 10.75
         Y = 6.305
*END ML.
         CALL GSPOS('CASA',N,'PAME',X,Y,Z,1,'ONLY')
         N = 3
*ML:
C         X = -10.75
         X = -5.5095
C         Y = 14.1
         Y = 17.215
*END ML.
         CALL GSPOS('CASA',N,'PAME',X,Y,Z,4,'ONLY')
         N = 4
*ML:
C         X = -14.1
         X = -17.9285
C         Y = -10.75
         Y = -10.195
*END ML.
         CALL GSPOS('CASA',N,'PAME',X,Y,Z,6,'ONLY')
*end JeL.
      ENDIF
*END: EM.
*
* Positioning volume SPEB     into the mother PAME
*
      N= 1
      X= 0.
      Y= 0.
c ml: 24/11/03:
       Z=ZCAL+CALS(3)+3.7+SPEB(3)
c      Z= ZSPEC
      IF(SPE) CALL GSPOS('SPEB',N,'PAME',X,Y,Z,0,'ONLY')
c end ml.
*
* Positioning volume S31     into the mother PAME
*
      N= 1
      X= 0.
      Y= 0.
c ml: 24/11/04:
      Z=ZCAL+CALS(3)+1.8+2*S32(3)+S31(3)
c      Z= ZS31
      IF(TOF) CALL GSPOS('S31 ',N,'PAME',X,Y,Z,0,'ONLY')
c end ml.
*
* Positioning volume S32     into the mother PAME
*
      N= 1
      X= 0.
      Y= 0.
c ml: 24/11/04:
      Z=ZCAL+CALS(3)+1.8+S32(3)
c      Z= ZS32
      IF(TOF) CALL GSPOS('S32 ',N,'PAME',X,Y,Z,0,'ONLY')
c end ml.
*
* Positioning volume CALB     into the mother PAME
*
      N= 1
      X= 0.
      Y= 0.
      Z= ZCAL
      IF(CAL) CALL GSPOS('CALS',N,'PAME',X,Y,Z,0,'ONLY')
*
* Positioning volume S4     into the mother PAME
*
      N= 1
c ml: 24/11/04:
      Z=ZCAL-CALS(3)-S4(3)
C      Z= ZS4
      IF(TOF) CALL GSPOS('S4  ',N,'PAME',X,Y,Z,0,'ONLY')
c end ml.
*
* User action
*
      CALL GPUGEO
      RETURN
      END

      PROGRAM READSEEDS
C # A simple program to read out the seed in a binary file
      integer lun,length
      integer ran(4)
      character*256 filename 

      lun=1
      print*, " Please enter the filename :"
      read*,filename
      length=len_trim(filename)
      print*, " Opening file : ",filename(1:len_trim(filename))
      open(unit=lun,file=filename,
     +     status='old',form='unformatted')
      read(lun) ran
      print*, " Seeds found : ",ran
      close(lun)
      stop
      end

*
* $Id: gutrev.F,v 3.4 2005/06/21 02:41:55 cafagna Exp $
*
* $Log: gutrev.F,v $
* Revision 3.4  2005/06/21 02:41:55  cafagna
* Major modification to the geometry and to the random number chain
*
* Revision 3.3  2004/04/06 10:33:45  pamela
* NON-REPRODUCIBILITY problem of a GPAMELA RUN fixed; bug found and fixed filling in the hit structure of the calorimeter
*
* Revision 3.2  2003/12/17 11:32:48  pamela
* CALO SIMULATION COMPLETED: geometry and special tracking parameters updated and simulation checked by a comparison with the Trieste's standalone Monte Carlo simulation
*
* Revision 3.1.1.1  2002/07/11 16:02:00  cafagna
* First GPAMELA release on CVS
*
*
*CMZ :  2.01/00 05/04/2000  14.35.18  by  Marialuigia Ambriola
*CMZ :  2.00/00 24/02/2000  20.09.11  by  Francesco Cafagna
*CMZ :  1.00/02 06/02/96  17.34.50  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   30/11/95
      SUBROUTINE GUTREV
************************************************************************
*                                                                      *
*             User routine to control tracking of one event            *
*                                                                      *
* A new coding of the calorimeter strips have been added to the hit    * 
* structure.                                                           *
* The energy release calculated in gpucal is mapped for each silicon   *
* detector, i.e. nine pads for each plane. The plane is read by strips.* 
* Each strip is the sum of three pads.                                 *
* This is way at the end of the event we sum up the aligned strips of  *
* three pads in the ENEPROVA matrix. To track the sum pattern we       *
* provide a mapping matrix filled with the sum of 1,100 or 10000,      *
* depending on the hitted sector.                                      *
* This hit structure is added to the calorimeter detector CASI and     *
* filled at the end of the event                                       *
*                                                                      *
*                                                                      *
* Called by: GRUN                                                      *
* Author: Francesco Cafagna, 30/11/95 17.22.48                         *
*                                                                      *
************************************************************************
#include "gcflag.inc"
#include "gpgene.inc"
*ml:
#include "gpphit.inc"
      PARAMETER (NH=NHCAL,NHM=NHMCAL,NVOL=3,NVOL1=2)
#include "gpencal.inc"
#include "gpcal.inc"
#include "gpsed.inc"
*
      INTEGER MAPCASI(44,96)
C new hit structure for calorimeter:
      INTEGER NUMVOL(20),IDHIT
      REAL VHIT(NHCAL)
C
*end ml.
*
* User action
*
      CALL GPUTRE(1)
*
*     -----------------------------------------------------------------
*
C
C # Increment number of event
C
      IEVNT = IEVNT +1
      CALL GTREVE
c new hit structure for calorimeter:
      CALL VZERO(VHIT,NHCAL)
c
      CALL VZERO(ENEPROVA,44*96)
      CALL VZERO(MAPCASI,44*96)
      DO IPL=1,44
         DO IMOD=1,9
            DO IST=1,32
               IF(ENEMAT(IPL,IMOD,IST).GT.0.) THEN
                  IF(IMOD.GE.1.AND.IMOD.LE.3) THEN
                     ENEPROVA(IPL,IST)=ENEPROVA(IPL,IST)+
     +                    ENEMAT(IPL,IMOD,IST)
                     IF(IMOD.EQ.1) MAPCASI(IPL,IST)=
     +                    MAPCASI(IPL,IST)+1
                     IF(IMOD.EQ.2) MAPCASI(IPL,IST)=
     +                    MAPCASI(IPL,IST)+100
                     IF(IMOD.EQ.3) MAPCASI(IPL,IST)=
     +                    MAPCASI(IPL,IST)+10000
                  ELSEIF(IMOD.GT.3.AND.IMOD.LT.7) THEN
                     ENEPROVA(IPL,IST+32)=ENEPROVA(IPL,IST+32)+
     +                    ENEMAT(IPL,IMOD,IST)
                     IF(IMOD.EQ.4) MAPCASI(IPL,IST+32)=
     +                    MAPCASI(IPL,IST+32)+1
                     IF(IMOD.EQ.5) MAPCASI(IPL,IST+32)=
     +                    MAPCASI(IPL,IST+32)+100
                     IF(IMOD.EQ.6) MAPCASI(IPL,IST+32)=
     +                   MAPCASI(IPL,IST+32)+10000
                  ELSEIF(IMOD.GE.7.AND.IMOD.LE.9) THEN
                     ENEPROVA(IPL,IST+64)=ENEPROVA(IPL,IST+64)+
     +                    ENEMAT(IPL,IMOD,IST)
                     IF(IMOD.EQ.7) MAPCASI(IPL,IST+64)=
     +                    MAPCASI(IPL,IST+64)+1
                     IF(IMOD.EQ.8) MAPCASI(IPL,IST+64)=
     +                    MAPCASI(IPL,IST+64)+100
                     IF(IMOD.EQ.9) MAPCASI(IPL,IST+64)=
     +                   MAPCASI(IPL,IST+64)+10000
                  ELSE
                     PRINT*,'IMOD=',IMOD
                  ENDIF
               ENDIF
            ENDDO
         ENDDO
      ENDDO
c filling the hit structure:
      NTHCAL=0
      DO I=1,44
         DO II=1,96
            IF(ENEPROVA(I,II).GT.0.) THEN
               NTHCAL=NTHCAL+1
C #                Vhit(1)=I
C #                Vhit(2)=II
C #                Vhit(3)=Mapcasi(I,Ii)
C #                Vhit(4)=Eneprova(I,Ii)
C #                Numvol(1)=Vhit(1)
C #                NUMVOL(2)=VHIT(3)
C #                NUMVOL(3)=VHIT(2)
c               IS=12
c               ID=1
               VHIT(1)=MAPCASI(I,II)
               VHIT(2)=ENEPROVA(I,II)
               NUMVOL(1)=I
               NUMVOL(2)=II
               IS=ISCAL
               ID=IDCASI
               IDHIT=-1
               CALL GSAHIT(IS,ID,1,NUMVOL,VHIT,IDHIT)
            ENDIF
         ENDDO
      ENDDO
      CALL VZERO(ENEMAT,44*9*32)

*
* User action
*
      CALL GPUTRE(2)
*
*             Debug and plot tracks.
*
      CALL GDEBUG
      RETURN
      END

*
* $Id: gpfil.F,v 3.2 2003/12/17 11:32:47 pamela Exp $
*
* $Log: gpfil.F,v $
* Revision 3.2  2003/12/17 11:32:47  pamela
* CALO SIMULATION COMPLETED: geometry and special tracking parameters updated and simulation checked by a comparison with the Trieste's standalone Monte Carlo simulation
*
* Revision 3.1.1.1  2002/07/11 16:02:00  cafagna
* First GPAMELA release on CVS
*
*
*               14/04/2005  12:59     by Marialuigia Ambriola
*CMZ :  3.00/00 30/03/2001  14.16.15  by  Marialuigia Ambriola
*CMZ :  2.01/00 08/03/2000  18.33.09  by  Unknown
*CMZ :  2.00/00 03/03/2000  15.39.05  by  Francesco Cafagna
*CMZ :  1.02/00 22/10/99  17.53.59  by  Francesco Cafagna
*CMZ :  1.01/00 02/05/96  09.43.56  by  Francesco Cafagna
*CMZ :  1.00/02 21/02/96  10.12.34  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   30/11/95
      SUBROUTINE GPFIL
************************************************************************
*                                                                      *
*            To open FFREAD and HBOOK files
*
* Called by: GPAMELA,GXINT
*                                                                      *
* Author: Francesco Cafagna, 30/11/95 15.53.48                         *
*                                                                      *
************************************************************************
#include "gppntp.inc"
#include "gpunit.inc"
*
#include "gcflag.inc"
#include "gcbank.inc"
*ML: 3/5/03
#include "gpkey.inc"
#include "gpseed.inc"
#include "gcunit.inc"
*END ML
      LOGICAL EXISTS
      INTEGER IJUNK
      CHARACTER*160 FNAM
      CHARACTER*4 SUF
*
* User action
*
      CALL GPUFIL
*
*             Open a HBOOK4 direct access file
*
      CALL HROPEN(LUHBK,'GPAMELA',CHHBK,'N',NBSIZE,ISTAT)
*
*             Open the magnetic field map
*
C fc +SELF,IF=UNIX.
C fc       OPEN(UNIT=LUFMAP,FILE=CHFMAP,FORM='UNFORMATTED',
C fc      +     STATUS='OLD')
C fc +SELF,IF=-UNIX.
C fc       OPEN(UNIT=LUFMAP,FILE=CHFMAP,FORM='UNFORMATTED',SHARED,
C fc      +     STATUS='OLD',READONLY)
C fc +SELF.
*ML:
CML17/04/2003      CALL HROPEN(LUFMAP,'FIELD',CHFMAP,' ',NBSIZE,ISTAT)
      CALL HROPEN(LUFMAP,'FIELD',CHFMAP,' ',1024,ISTAT)
*END ML.
*
*ML: (to simulate the TR from TRD)
      OPEN(UNIT=LUTR,FILE=CHTR,FORM='UNFORMATTED',STATUS='UNKNOWN')
*END ML.
*Ml 27/04/04:
      IF(HSEED.EQ.1.OR.HSEED.EQ.2) THEN
         INQUIRE(FILE=CHFSF,EXIST=EXISTS)      
         OPEN(UNIT=LUFSF,FILE=CHFSF,FORM='UNFORMATTED',STATUS='OLD')
      ELSE
         WRITE(CHMAIL,10000) 
         CALL GMAIL(1,0)
      ENDIF
      IF(DCLSFI) THEN
         FNAM=CHLSF
      ELSE
         SUF='SEED'
         IJUNK=INDEX(CHHBK,'HIS')
         FNAM = CHHBK(1:IJUNK-1)//SUF         
      ENDIF
C      OPEN(UNIT=LULSF,FILE=CHLSF,FORM='UNFORMATTED',STATUS='UNKNOWN')
      OPEN(UNIT=LULSF,FILE=FNAM,FORM='UNFORMATTED',STATUS='UNKNOWN')
*end ml. 27/04/04
10000 FORMAT(' GPFIL WARNING: wrong value for data card HFSF. ',
     + 'Input file for random seed not       opened. ',
     +  'The program will ignore this data card.')
      END

*
* $Id: gpspev.F,v 3.2 2005/06/21 02:42:27 cafagna Exp $
*
* $Log: gpspev.F,v $
* Revision 3.2  2005/06/21 02:42:27  cafagna
* Major modification to the geometry and to the random number chain
*
* Revision 3.1.1.1  2002/07/11 16:02:14  cafagna
* First GPAMELA release on CVS
*
*
*CMZ :  2.01/00 05/04/2000  14.35.18  by  Marialuigia Ambriola
*CMZ :  2.00/00 03/03/2000  15.39.06  by  Francesco Cafagna
*CMZ :  1.02/00 07/03/97  14.48.41  by  Francesco Cafagna
*CMZ :  1.00/02 06/02/96  17.34.50  by  Francesco Cafagna
*-- Author :    Francesco Cafagna   09/12/95
      SUBROUTINE GPSPEV
************************************************************************
*                                                                      *
* Volumes definition for the silicon tracking system and magnet        *
* Called by: GPGEM                                                     *
* Author: Francesco Cafagna, 05/12/95 13.39.41                         *
*                                                                      *
************************************************************************
#include "gpgeo.inc"
#include "gpmed.inc"
*
      INTEGER IROT,IVOLU,N,NMED,NUM
      REAL X,Y,Z
*
*  Define the SPEB     volume
*
      NMED= MN2
      CALL GSVOLU('SPEB','BOX ',NMED,SPEB, 3,IVOLU)
*
*  Define the MGFR     volume
*
      NMED= MAL
      CALL GSVOLU('MGFR','BOX ',NMED,MGFR, 3,IVOLU)
*
*  Define the MGPL     volume
*
      NMED= MMAG
      CALL GSVOLU('MGPL','BOX ',NMED,MGPL, 3,IVOLU)
*
*  Define the MGPI     volume
*
      NMED= MN2
      CALL GSVOLU('MGPI','BOX ',NMED,MGPI, 3,IVOLU)
*
*  Define the TRPB     volume
*
      NMED= MAL
      CALL GSVOLU('TRPB','BOX ',NMED,TRPB, 3,IVOLU)
*****
cC ml 20/04/05:
*
cc*  Define the TRPL     volume
*  Define the TPAS and TPAI volume
*
      NMED= MN2
CC      CALL GSVOLU('TRPL','BOX ',NMED,TRPL, 3,IVOLU)
      CALL GSVOLU('TPAS','BOX ',NMED,TPAS, 3,IVOLU)
      NMED= MAL
      CALL GSVOLU('TPAI','BOX ',NMED,TPAI, 3,IVOLU)
CC end ml.
****************
*
*  Define the TRSL     volume
*
c ml: 26/11/04:
c      NMED= MN2
      NMED=MSIT
      CALL GSVOLU('TRSL','BOX ',NMED,TRSL, 3,IVOLU)
*
* Define the THBP volume
*
      NMED=MG10C
      CALL GSVOLU('THBP','BOX ',NMED,THBP, 3,IVOLU)
C end ml.
*
*  Define the TSPA     volume
*
      NMED= MSIT
      CALL GSVOLU('TSPA','BOX ',NMED,TSPA, 3,IVOLU)
*
*  Define the TRCP     volume
*
      NMED= MCF
      CALL GSVOLU('TRCP','BOX ',NMED,TRCP, 3,IVOLU)
*
* Positioning volume TSPA     into the mother TRSL
*
      N= 1
      X= 0.
c ml: 26/11/66:
c      Y= TRSL(2) - TSPA(2)
C #       Y=+TRSL(2)/2
      Y= 0.
      Z= 0.
      CALL GSPOS('TSPA',N,'TRSL',X,Y,Z,0,'ONLY')
C #       N= 2
C # C      Y= Y - 2.*TSPA(2)
C #       Y=-TRSL(2)/2
C #       CALL GSPOS('TSPA',N,'TRSL',X,Y,Z,0,'ONLY')
c ml: 26/11/04:
*
c* Positioning volume TRCP     into the mother TRSL
CC ml 20/04/05: 
CC* Positioning volume TRCP into mother TRPL
* Positioning volume TRCP into mother TRPB
*
c      N= 1
CC ml 20/04/05: 
cc      Z= 0.
cc      Y= 0.
C # Caf mod on 19 Jul 2005 all volumes are placed inside the TPAS one
C #       Z=-TRPB(3)+0.11+TRCP(3)
C #       Y=-TRPB(2)+1.5-0.225+TRCP(2)
CC end ml.
      Z=-0.005
      y=-0.225-TPAS(2)+TRCP(2)
C # end CAF mod
      DO I=1,4
CC ml 20/04/05:         
CC         X=-TRPL(1)+(2*I-1)*TRCP(1)+2*(I-1)*TRSL(1)
C # Caf mod on 19 Jul 2005 all volumes are placed inside the TPAS one
C #          X=-TRPB(1)+2.29+(2*I-1)*TRCP(1)+2*(I-1)*TRSL(1)
         X=-TPAS(1)+(2*I-1)*TRCP(1)+2*(I-1)*TRSL(1)
CC end ml
c         CALL GSPOS('TRCP',I,'TRPL',X,Y,Z,0,'ONLY')
C #          CALL GSPOS('TRCP',I,'TRPB',X,Y,Z,0,'ONLY')
         CALL GSPOS('TRCP',I,'TPAS',X,Y,Z,0,'ONLY')
C # end CAF mod
      ENDDO  
c      X= -TRSL(1) + TRCP(1)
c      CALL GSPOS('TRCP',N,'TRSL',X,Y,Z,0,'ONLY')
C      N= 2
C      X= -X
C      CALL GSPOS('TRCP',N,'TRSL',X,Y,Z,0,'ONLY')
*****
cc ml 20/04/05:
*
*** Positioning volume TRSL     into the mother TRPL
* Positioning volume TRSL     into the mother TRPB
*
c ml: 26/11/04:
C      Y= 0.
cc      Y=THBP(2)
C # Caf mod on 19 Jul 2005 all volumes are placed inside the TPAS one
C #       Y=-TRPB(2)+1.5+2*THBP(2)+TRSL(2)
C      Y=2.75
CC      Z= 0.
C #       Z=-TRPB(3)+0.11+TRCP(3)
      Z=-0.005
      DO I=1, NTRSL
         X=-TPAS(1)+2*(MOD(I-1,3)+1)*TRCP(1)+
     +        (2*(MOD(I-1,3)+1)-1)*TRSL(1)
         IF(I.LE.3) THEN
            Y=TPAS(2)-TRSL(2)
         ELSE
            Y=TPAS(2)-3*TRSL(2)
         ENDIF
         CALL GSPOS('TRSL',I,'TPAS',X,Y,Z,0,'ONLY')
      ENDDO
C # end CAF mod
**********
cc ml: 20/04/05
*
********* Positioning volume THBP     into the mother TRPL
* Positioning volume THBP     into the mother TRPB
*
cc      Y=-TRSL(2)
C # Caf mod on 19 Jul 2005 all volumes are placed inside the TPAS one
C #       Y=-TRPB(2)+1.5+THBP(2)
C # cc      Z= 0.
C #       Z=-TRPB(3)+0.11+TRCP(3)
      Y=-TPAS(2)+THBP(2)
      Z=-0.005
      DO I=1, NTHBP
CC         X= -TRPL(1) + 2*I*TRCP(1)+(2*I-1)*THBP(1)
C #          X=-TRPB(1)+2.29+2*I*TRCP(1)+(2*I-1)*THBP(1)
         X=-TPAS(1)+2*I*TRCP(1)+(2*I-1)*THBP(1)
cc         CALL GSPOS('THBP',I,'TRPL',X,Y,Z,0,'ONLY')
C #          CALL GSPOS('THBP',I,'TRPB',X,Y,Z,0,'ONLY')
         CALL GSPOS('THBP',I,'TPAS',X,Y,Z,0,'ONLY')
      ENDDO
c end ml.
cc ml: 20/04/05
*
* Positioning volume TPAI into the mother TRPB
*
C # Mod By Caf on 19th Jul 2005 all volumes inside the TPAS
      X=0
      Y=-TPAS(2)+TPAI(2)
      Z=-TPAS(3)+TPAI(3)
C #       X=-TRPB(1)+2.29+TPAI(1)
C #       Y=-TRPB(2)+1.5+2.5+TPAI(2)
C #       Z=-TRPB(3)+TPAI(3)
      CALL GSPOS('TPAI',I,'TPAS',X,Y,Z,0,'ONLY')
C # end CAF mod
*
* Positioning volume TPAS into the mother TRPB
*
C # Mod By Caf on 15th Jul 2005
      X=0
      Y=-TRPB(2)+1.5+TPAS(2)
      Z=0
C #       X=-TRPB(1)+2.29+TPAS(1)
C #       Y=-TRPB(2)+1.5+TPAS(2)
C #       Z=-TRPB(3)+0.11+2*TRCP(3)+TPAS(3)
      CALL GSPOS('TPAS',I,'TRPB',X,Y,Z,0,'ONLY')
c end ml.

*
* Positioning volume MGPI     into the mother MGPL
*
      N= 1
      X= 0.
      Y= 0.
      Z= 0.
      CALL GSPOS('MGPI',N,'MGPL',X,Y,Z,0,'ONLY')
*
* Positioning volume MGPL     into the mother MGFR
*
      CALL GSPOS('MGPL',N,'MGFR',X,Y,Z,0,'ONLY')
C Ml: 20/04/05:
c*
c* Positioning volume TRPL     into the mother TRPB
c*
c      N= 1
c      Z= 0.
c      CALL GSPOS('TRPL',N,'TRPB',X,Y,Z,0,'ONLY')
c end ml.
*
* Positioning volumes TRPB & MGPL into the mother SPEB
*
      N= 1
      X= 0.
      Y= SPEB(2) - TRPB(2)
      Z= SPEB(3) - TRPB(3)
      CALL GSPOS('TRPB',N,'SPEB',X,Y,Z,0,'ONLY')
      DO I=1, 5
         X= 0.
         Y= 0.
         Z= Z - TRPB(3) - MGFR(3)
         N= I
         CALL GSPOS('MGFR',N,'SPEB',X,Y,Z,0,'ONLY')
         Y= SPEB(2) - TRPB(2)
         Z= Z - MGFR(3) - TRPB(3)
         N= (I+1)
         IF(I.EQ.5) THEN
            CALL GSPOS('TRPB',N,'SPEB',X,Y,Z,10,'ONLY')
         ELSE
            CALL GSPOS('TRPB',N,'SPEB',X,Y,Z,0,'ONLY')
         ENDIF
      ENDDO
*
      RETURN
      END
